Index: GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2036)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2039)
@@ -37,10 +37,10 @@
 
 
-$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
--view_cells_use_kd_pvs+ -af_use_kd_pvs+ \
--preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4l.xml \
--preprocessor_stats=$PREFIX-i-mixed-b1-n4l.log \
--preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4l.hlog
+# $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
+# -view_cells_use_kd_pvs+ -af_use_kd_pvs+ \
+# -preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4l.xml \
+# -preprocessor_stats=$PREFIX-i-mixed-b1-n4l.log \
+# -preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4l.hlog
 
 $COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
@@ -49,30 +49,40 @@
 -preprocessor_histogram_file=$PREFIX-r-reference.hlog
 
-$COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
- -rss_distributions=direction -view_cells_filter_max_size=1 \
- -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
- -preprocessor_stats=$PREFIX-r-reference-global.log \
- -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
+# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+#  -rss_distributions=direction -view_cells_filter_max_size=1 \
+#  -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
+#  -preprocessor_stats=$PREFIX-r-reference-global.log \
+#  -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
 
 
-$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
--view_cells_use_kd_pvs- -af_use_kd_pvs+ \
--preprocessor_visibility_file=$PREFIX-i-mixed-bvh-n4k.xml \
--preprocessor_stats=$PREFIX-i-mixed-bvh-n4k.log \
--preprocessor_histogram_file=$PREFIX-i-mixed-bvh-n4k.hlog
+# $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
+# -view_cells_use_kd_pvs- -af_use_kd_pvs+ \
+# -preprocessor_visibility_file=$PREFIX-i-mixed-bvh-n4k.xml \
+# -preprocessor_stats=$PREFIX-i-mixed-bvh-n4k.log \
+# -preprocessor_histogram_file=$PREFIX-i-mixed-bvh-n4k.hlog
 
-$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--view_cells_use_kd_pvs- -af_use_kd_pvs+ \
--preprocessor_visibility_file=$PREFIX-r-bvh-reference.xml \
--view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-bvh-reference.log \
--preprocessor_histogram_file=$PREFIX-r-bvh-reference.hlog
+# $COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -view_cells_use_kd_pvs- -af_use_kd_pvs+ \
+# -preprocessor_visibility_file=$PREFIX-r-bvh-reference.xml \
+# -view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-bvh-reference.log \
+# -preprocessor_histogram_file=$PREFIX-r-bvh-reference.hlog
 
-$COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--view_cells_use_kd_pvs- -af_use_kd_pvs+ \
- -rss_distributions=direction -view_cells_filter_max_size=1 \
- -preprocessor_visibility_file=$PREFIX-r-bvh-reference-global.xml \
- -preprocessor_stats=$PREFIX-r-bvh-reference-global.log \
- -preprocessor_histogram_file=$PREFIX-r-bvh-reference-global.hlog
+# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -view_cells_use_kd_pvs- -af_use_kd_pvs+ \
+#  -rss_distributions=direction -view_cells_filter_max_size=1 \
+#  -preprocessor_visibility_file=$PREFIX-r-bvh-reference-global.xml \
+#  -preprocessor_stats=$PREFIX-r-bvh-reference-global.log \
+#  -preprocessor_histogram_file=$PREFIX-r-bvh-reference-global.hlog
+
+
+
+#############
+#############
+#############
+#############
+#############
+
+
 
 # $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \