Index: /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2039)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2049)
@@ -31,5 +31,5 @@
 VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
 
-PREFIX=../work/plots/osp-1e5
+PREFIX=../work/plots/osp-TEST-1e5
 
 #SCENE=../data/atlanta/atlanta2.x3d
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_pompeii
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_pompeii	(revision 2043)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_pompeii	(revision 2049)
@@ -10,9 +10,10 @@
 PREFIX=../work/plots/osp-pompeii4-1e5
 
-$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
- -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
- -preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4n.xml \
- -preprocessor_stats=$PREFIX-i-mixed-b1-n4n.log \
- -preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4n.hlog
+
+# $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+#  -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
+#  -preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4n.xml \
+#  -preprocessor_stats=$PREFIX-i-mixed-b1-n4n.log \
+#  -preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4n.hlog
 
 # # n - no origin mutation, q=2, reverse samples
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2048)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2049)
@@ -1456,7 +1456,24 @@
 	//	renderer->mRenderingFinished.wait(&mutex);
 	//	mutex.unlock();
-	
-	renderer->EvalPvsStat();
-
+
+	if (mViewCellsManager->GetViewCellPoints()->size()) {
+	  
+	  vector<ViewCellPoints *> *vcPoints = mViewCellsManager->GetViewCellPoints();
+	  
+	  vector<ViewCellPoints *>::const_iterator vit, vit_end = vcPoints->end();
+	  SimpleRayContainer viewPoints;
+	  
+	  for (vit = vcPoints->begin(); vit != vit_end; ++ vit) {
+		ViewCellPoints *vp = *vit;
+
+		SimpleRayContainer::const_iterator rit = vp->second.begin(), rit_end = vp->second.end();
+		for (; rit!=rit_end; ++rit)
+		  viewPoints.push_back(*rit);
+	  }
+	  
+	  renderer->EvalPvsStat(viewPoints);
+	} else
+	  renderer->EvalPvsStat();
+	
 	mStats <<
 	  "#AvgPvsRenderError\n" <<renderer->mPvsStat.GetAvgError()<<endl<<
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2048)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2049)
@@ -96,6 +96,7 @@
   unsigned int pixelCount;
 
-
+  
   ViewCell *viewcell = mViewCellsManager->GetViewCell(mViewPoint);
+  
   if (viewcell == NULL)
 	return 0.0f;
@@ -166,5 +167,5 @@
   
   
-  if (mSnapErrorFrames && pErrorPixels >= 0.01f) {
+  if (0 && mSnapErrorFrames && pErrorPixels >= 0.01f) {
 	
 	char filename[256];
@@ -448,121 +449,56 @@
 {
   float pErrorPixels = -1.0f;
-
-  glReadBuffer(GL_BACK);
-  
-  mUseFalseColors = true;
-
-  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-  
-  double eq[4];
-  eq[0] = mSceneCutPlane.mNormal.x;
-  eq[1] = mSceneCutPlane.mNormal.y;
-  eq[2] = mSceneCutPlane.mNormal.z;
-  eq[3] = mSceneCutPlane.mD;
-  
-  if (mCutScene) {
-	glClipPlane(GL_CLIP_PLANE0, eq);
-    glEnable(GL_CLIP_PLANE0);
-  }
-  
-  if (mDetectEmptyViewSpace) 
-	glEnable( GL_CULL_FACE );
-  else
-	glDisable( GL_CULL_FACE );
-
-  ObjectContainer::const_iterator oi = mObjects.begin();
-  for (; oi != mObjects.end(); oi++)
-	RenderIntersectable(*oi);
-
-  ViewCell *viewcell = NULL;
-
-  QImage im1, im2;
-  QImage diff;
-  
-  if (viewcell) {
-	// read back the texture
-	im1 = grabFrameBuffer(true);
-	
-	RenderPvs();
-
-	// read back the texture
-	im2 = grabFrameBuffer(true);
-	
-	diff = im1;
-	int x, y;
-	int errorPixels = 0;
-	
-	for (y = 0; y < im1.height(); y++)
-	  for (x = 0; x < im1.width(); x++)
-		if (im1.pixel(x, y) == im2.pixel(x, y))
-		  diff.setPixel(x, y, qRgba(0,0,0,0));
-		else {
-		  diff.setPixel(x, y, qRgba(255,128,128,255));
-		  errorPixels++;
-		}
-	pErrorPixels = ((float)errorPixels)/(im1.height()*im1.width());
-  }
-
-  // now render the pvs again
+  
   SetupCamera();
-  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-  mUseFalseColors = false;
-  
-  oi = mObjects.begin();
-  for (; oi != mObjects.end(); oi++)
-	RenderIntersectable(*oi);
-
-  // now render im1
-  if (viewcell) {
-	if (0 && mTopView) {
-	  mWireFrame = true;
-	  RenderIntersectable(viewcell);
-	  mWireFrame = false;
-	}
-	
-	// init ortographic projection
-	glMatrixMode(GL_PROJECTION);
-	glPushMatrix();
-	
-	glLoadIdentity();
-	gluOrtho2D(0, 1.0f, 0, 1.0f);
-	
-	glMatrixMode(GL_MODELVIEW);
-	glLoadIdentity();
-	
-	bindTexture(diff);
-	
-	glPushAttrib(GL_ENABLE_BIT);
-	glEnable( GL_ALPHA_TEST );
-	glDisable( GL_CULL_FACE );
-	glAlphaFunc( GL_GREATER, 0.5 );
-	
-	glEnable( GL_TEXTURE_2D );
-	glBegin(GL_QUADS);
-	
-	glTexCoord2f(0,0);
-	glVertex3f(0,0,0);
-	
-	glTexCoord2f(1,0);
-	glVertex3f( 1, 0, 0);
-	
-	glTexCoord2f(1,1);
-	glVertex3f( 1, 1, 0);
-	
-	glTexCoord2f(0,1);
-	glVertex3f(0, 1, 0);
-	glEnd();
-	
-	glPopAttrib();
-	
-	// restore the projection matrix
-	glMatrixMode(GL_PROJECTION);
-	glPopMatrix();
-	glMatrixMode(GL_MODELVIEW);
-  }
-
-  glDisable(GL_CLIP_PLANE0);
-  
+  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
+
+  glPushAttrib(GL_ENABLE_BIT);
+
+  glStencilFunc(GL_EQUAL, 0x0, 0x1);
+  glStencilOp(GL_KEEP, GL_KEEP, GL_INCR); 
+
+  mUseForcedColors = true;
+
+  glColor3f(0.0f, 0.8f, 0.2f);
+
+  // 	// Render PVS
+  RenderPvs();
+  
+  glEnable(GL_STENCIL_TEST); 
+  
+  //  mUseFalseColors = true;
+  
+  glDisable(GL_LIGHTING);
+  
+  OcclusionQuery *query = mOcclusionQueries[0];
+  query->BeginQuery();
+  
+  SetupCamera();
+
+  glColor3f(1.0f, 0.0f, 0.0f);
+  
+  RenderScene();
+
+  mUseForcedColors = false;
+
+  query->EndQuery();
+  
+  glDisable(GL_STENCIL_TEST);
+  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
+
+  glPopAttrib();
+
+  // reenable other state
+  //  int wait=0;
+  //  while (!query.ResultAvailable()) {
+  //  	wait++;
+  //  }
+
+  int pixelCount = query->GetQueryResult();
+  pErrorPixels = ((float)pixelCount)/(GetWidth()*GetHeight());
+  cout<<"error pixels="<<pixelCount<<endl;
+
   mRenderError = pErrorPixels;
+
   return pErrorPixels;
 }
@@ -719,8 +655,21 @@
 	if (!ok)
 	  break;
+	
 	if (sscanf(text.toAscii(), "%f %f %f", &mViewPoint.x, &mViewPoint.y, &mViewPoint.z) == 3) {
-	  updateGL();
+	  text.sprintf("%f %f %f", mViewDirection.x, mViewDirection.y, mViewDirection.z);
+	  text = QInputDialog::getText(this,
+								   "Enter a direction",
+								   "",
+								   QLineEdit::Normal,
+								   text,
+								   &ok);
+	  if (!ok)
+		break;
+	  if (sscanf(text.toAscii(), "%f %f %f", &mViewDirection.x,
+				 &mViewDirection.y, &mViewDirection.z) == 3) {
+		updateGL();
+	  }
+	  break;
 	}
-	break;
   }
   default:
@@ -1058,6 +1007,7 @@
   
   glEnable(GL_CULL_FACE);
-  //glDisable(GL_CULL_FACE);
   glCullFace(GL_FRONT);
+
+  glDisable(GL_CULL_FACE);
   double eq[4];
   eq[0] = mSceneCutPlane.mNormal.x;
@@ -1089,5 +1039,4 @@
 	//	Mesh *m = vc->GetMesh();
 
-
 	RgbColor c;
 
@@ -1097,5 +1046,6 @@
 	} else {
 	  //	  const float importance = 5.0f*mTransferFunction * ((float)vc->GetPvs().CountObjectsInPvs() / (float)maxPvs);
-	  const float importance = 5.0f*mTransferFunction * ((float)vc->GetPvs().GetSize() / (float)maxPvs);
+	  const float importance = 5.0f*mTransferFunction *
+		((float)vc->GetPvs().GetSize() / (float)maxPvs);
 	  c = RgbColor(importance, 1.0f - importance, 0.0f);
 	}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2011)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2049)
@@ -199,4 +199,6 @@
 
 ViewCells {
+	importRandomViewCells true
+
 	useKdPvs true
 	useKdPvsAfterFiltering true
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingPreprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingPreprocessor.cpp	(revision 2046)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingPreprocessor.cpp	(revision 2049)
@@ -175,7 +175,10 @@
 	  }
 	  
-	  if (mTotalTime != -1 && time/1000 > mTotalTime)
-		break;
 	}
+
+	long time = TimeDiff(startTime, GetTime());
+	if (mTotalTime != -1 && time/1000 > mTotalTime)
+	  break;
+	
   }
   if (0) {
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2048)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2049)
@@ -92,8 +92,12 @@
   //mUseGlLists = false;
 
-  Environment::GetSingleton()->GetIntValue("Preprocessor.pvsRenderErrorSamples", mPvsStatFrames);
+  if (mViewCellsManager->GetViewCellPoints()->size())
+	mPvsStatFrames = mViewCellsManager->GetViewCellPoints()->size();
+  else
+	Environment::GetSingleton()->GetIntValue("Preprocessor.pvsRenderErrorSamples", mPvsStatFrames);
+
+
   mPvsErrorBuffer.resize(mPvsStatFrames);
   ClearErrorBuffer();
-  
 }
 
@@ -861,7 +865,7 @@
 {
 	MakeCurrent();
-
+	
 	GlRenderer::EvalPvsStat();
-
+	
 	DoneCurrent();
   //  mRenderingFinished.wakeAll();
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2042)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2049)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: út 23. I 16:04:45 2007
+# Generated by qmake (2.00a) (Qt 4.1.2) on: út 23. I 21:53:49 2007
 # Project:  preprocessor.pro
 # Template: app
@@ -63,5 +63,5 @@
 	$(MAKE) -f $(MAKEFILE).Debug uninstall
 
-Makefile: preprocessor.pro  C:/Qt/4.1.2/mkspecs/win32-msvc2005\qmake.conf C:/Qt/4.1.2/mkspecs/qconfig.pri \
+Makefile: preprocessor.pro  C:/Qt/4.1.2/mkspecs/win32-msvc.net\qmake.conf C:/Qt/4.1.2/mkspecs/qconfig.pri \
 		C:\Qt\4.1.2\mkspecs\features\qt_config.prf \
 		C:\Qt\4.1.2\mkspecs\features\exclusive_builds.prf \
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2048)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2049)
@@ -212,5 +212,6 @@
 	
 	const string externKdTree = ReplaceSuffix(filename, ".obj", ".kdf");
-	const string internKdTree = GetInternFilename(filename, preprocessor->mLoadMeshes ? ".kdm" : ".kdt");
+	const string internKdTree = GetInternFilename(filename, preprocessor->mLoadMeshes ?
+												  ".kdm" : ".kdt");
 
 	if (preprocessor->InitRayCast(externKdTree, internKdTree))
@@ -260,4 +261,5 @@
 		else
 		{
+		  
 			const string objname = GetInternFilename(filename, ".obj");
 
@@ -265,4 +267,5 @@
 			bool success = preprocessor->ExportObj(objname, preprocessor->mObjects);
 
+			
 			if (success)
 			{
@@ -342,7 +345,32 @@
 
 	bool guiSupported = false;
-	
+
+	bool useRendererBuffer = true;
+
+	int frames;
+	Environment::GetSingleton()->GetIntValue("Preprocessor.pvsRenderErrorSamples", frames);
+	
+	
+#ifdef USE_QT
+
+	if (importRandomViewCells || frames)
+	  {
+		QGLFormat f;
+		f.setStencil(true);
+		QGLFormat::setDefaultFormat(f);
+
+		// NOTE: render texture should be power of 2 and square
+		// renderer must be initialised
+		// $$matt
+		preprocessor->renderer = 
+		  new QtGlRendererBuffer(1024, 1024,
+								 preprocessor->mSceneGraph,
+							   preprocessor->mViewCellsManager,
+								 preprocessor->mKdTree);
+	  }
+#endif
+
 	if (preprocessor->mUseGlRenderer || preprocessor->mUseGlDebugger)
-	{
+	  {
 #ifdef USE_QT
 		cout << "using gl widget" << endl;
@@ -355,40 +383,27 @@
 		if (!rendererWidget) 
 		{
-			if (!QGLFormat::hasOpenGL() || !QGLPixelBuffer::hasOpenGLPbuffers()) {
-				QMessageBox::information(0, "OpenGL pbuffers", 
-					"This system does not support OpenGL/pbuffers.",
-					QMessageBox::Ok);
-				return NULL;
+
+		  if (!QGLFormat::hasOpenGL() || !QGLPixelBuffer::hasOpenGLPbuffers()) {
+			QMessageBox::information(0, "OpenGL pbuffers", 
+									   "This system does not support OpenGL/pbuffers.",
+									   QMessageBox::Ok);
+			  return NULL;
 			}
 
-			rendererWidget = 
-				new QtGlRendererWidget(preprocessor->mSceneGraph,
-									   preprocessor->mViewCellsManager,
-									   preprocessor->mKdTree);
-
-			rendererWidget->Show();
-
-			QtGlViewer *viewer = 
-				new QtGlViewer(NULL, (QtGlRendererWidget *)rendererWidget);
-
-			viewer->show();
-			guiSupported = true; 
-		}
-
-		int frames;
-		Environment::GetSingleton()->GetIntValue("Preprocessor.pvsRenderErrorSamples", frames);
-		
-		if (1)//frames) 
-		{
-			// NOTE: render texture should be power of 2 and square
-			// renderer must be initialised
-			// $$matt
-			preprocessor->renderer = 
-				new QtGlRendererBuffer(1024, 1024,
-									   preprocessor->mSceneGraph,
-									   preprocessor->mViewCellsManager,
-									   preprocessor->mKdTree);
-		}
-
+		  rendererWidget = 
+			new QtGlRendererWidget(preprocessor->mSceneGraph,
+								   preprocessor->mViewCellsManager,
+								   preprocessor->mKdTree);
+		  
+		  rendererWidget->Show();
+		  
+		  QtGlViewer *viewer = 
+			new QtGlViewer(NULL, (QtGlRendererWidget *)rendererWidget);
+		  
+		  viewer->show();
+		  guiSupported = true; 
+		}
+		
+		
 		bool exportRandomViewCells;
 		Environment::GetSingleton()->GetBoolValue("ViewCells.exportRandomViewCells",
@@ -410,5 +425,5 @@
 			preprocessor->ComputeRenderError();
 		}*/
-
+		
 		qApp->exec();
 #endif
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp	(revision 2048)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp	(revision 2049)
@@ -33,5 +33,6 @@
 	
   }
-  
+
+
 
 bool
@@ -129,8 +130,9 @@
 		ComputeRenderError();
 	  }
+	}
 
-	  if (mTotalTime!= -1 && time/1000 > mTotalTime)
-		break;
-	}
+	long time = TimeDiff(startTime, GetTime());
+	if (mTotalTime!= -1 && time/1000 > mTotalTime)
+	  break;
 
 #if 0
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_powerplant
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_powerplant	(revision 2022)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_powerplant	(revision 2049)
@@ -2,5 +2,5 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace-"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -total_samples=500000000"
 
 
@@ -12,23 +12,23 @@
 
 
-$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
- -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
- -view_cells_use_kd_pvs+ -af_use_kd_pvs+ \
- -preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4a.xml \
- -preprocessor_stats=$PREFIX-i-mixed-b1-n4a.log \
- -preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4a.hlog
+# $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+#  -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
+#  -view_cells_use_kd_pvs+ -af_use_kd_pvs+ \
+#  -preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4a.xml \
+#  -preprocessor_stats=$PREFIX-i-mixed-b1-n4a.log \
+#  -preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4a.hlog
 
 # n - no origin mutation, q=2, reverse samples
 
-# $COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
-# -preprocessor_visibility_file=$PREFIX-r-reference.xml \
-# -view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
-# -preprocessor_histogram_file=$PREFIX-r-reference.hlog
+$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-preprocessor_visibility_file=$PREFIX-r-reference.xml \
+-view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
+-preprocessor_histogram_file=$PREFIX-r-reference.hlog
 
-# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
-#  -rss_distributions=direction -view_cells_filter_max_size=1 \
-#  -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
-#  -preprocessor_stats=$PREFIX-r-reference-global.log \
-#  -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
+$COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+ -rss_distributions=direction -view_cells_filter_max_size=1 \
+ -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
+ -preprocessor_stats=$PREFIX-r-reference-global.log \
+ -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
 
 #mutation+object_direction+
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2042)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2049)
@@ -47,5 +47,8 @@
 }
 
-win32:LIBS += devil.lib ilu.lib ilut.lib glew32.lib zlib.lib zdll.lib zziplibd.lib
+win32:LIBS += devil.lib ilu.lib ilut.lib glew32.lib zlib.lib
+
+#zdll.lib
+#zziplibd.lib
 
 CONFIG(release) {
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 2048)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 2049)
@@ -1461,5 +1461,5 @@
     }
 
-  //cout<<"parsing started"<<endl<<flush;
+  //  cout<<"parsing started"<<endl<<flush;
 
   //
@@ -1508,5 +1508,5 @@
 #endif
 
-	if (PVS_HACK)
+	if (0 && PVS_HACK)
 		handler.ExchangeElements();
 