Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h	(revision 2025)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h	(revision 2057)
@@ -111,4 +111,5 @@
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("General");
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("PostProc");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Particles");
 	}
 
@@ -146,5 +147,5 @@
 		
 		
-		ParticleSystem* pSys1 = mSceneMgr->createParticleSystem("tuzecske", "GameTools/DemoParticle1");
+		ParticleSystem* pSys1 = mSceneMgr->createParticleSystem("tuzecske", "GTP/SBB");
 		pSys1->setKeepParticlesInLocalSpace(false);
 		SceneNode *pSysNode = rootNode->createChildSceneNode();
@@ -184,5 +185,6 @@
 		mainLightNode->attachObject(mainLight); 
 		
-		
+		OgreIlluminationManager::getSingleton().initTechniques();
+		/*
 		{//SBB
 				OgreSharedRuns* sharedruns = new OgreSharedRuns();
@@ -204,5 +206,5 @@
 			group->addRenderTechnique(techn);
 			renderer->getSpriteSet()->setRenderTechniqueGroup(group);
-		}
+		}*/
 		
    }
Index: GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 2025)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 2057)
@@ -360,4 +360,6 @@
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("General");
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("PostProc");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Basic");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Diffuse");
 	}
 
@@ -652,5 +654,5 @@
 
      	Entity* object = mSceneMgr->createEntity("object", "buddha.mesh");
-		object->setMaterialName("GameTools/Diffuse/use");
+		object->setMaterialName("GTP/Diffuse/Disc2Point");
 		//object->setMaterialName("GameTools/DiffuseP2P");
 		objectNode = rootNode->createChildSceneNode();
@@ -658,5 +660,5 @@
 		objectNode->scale(0.4,0.4,0.4);
 		objectNode->rotate(Vector3(0,1,0),Radian(Math::PI));
-		objectNode->setPosition(0,0,0);
+		objectNode->setPosition(0,1,0);
 		objectNode->_updateBounds();
 
Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/include/GameToolsRaytraceDemo.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/include/GameToolsRaytraceDemo.h	(revision 2025)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/include/GameToolsRaytraceDemo.h	(revision 2057)
@@ -30,5 +30,5 @@
 
 float causize = 10;
-float cauintens = 40;
+float cauintens = 1;
 
 // Listener class for frame updates
@@ -66,6 +66,6 @@
     }
 	bool processUnbufferedKeyInput(const FrameEvent& evt)
-    {/*
-		MaterialPtr mat = MaterialManager::getSingleton().getByName("GameTools/Cauathene_SE_0_clone");
+    {
+		MaterialPtr mat = MaterialManager::getSingleton().getByName("GTP/Caustic/CauCube_PointSpritecenterHead_SE_0_clone");
 		GpuProgramParameters* Vparams = mat->getTechnique(0)->getPass(0)->getVertexProgramParameters().getPointer();
 		GpuProgramParameters* Fparams = mat->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
@@ -75,6 +75,7 @@
 			cauintens -= 0.5;
 			cauintens = std::max(cauintens, 1.0f);
-			float intensity = pow( cauintens / 100.0f, 2 );
-			Fparams->setNamedConstant("CauSpriteIntens", intensity);			
+			float intensity = cauintens;
+			float causticColor[] = {1.0, 1.0, 1.0, intensity};
+			Fparams->setNamedConstant("CausticColor", causticColor, 4);				
 		}
 		if (mInputDevice->isKeyDown(KC_ADD))
@@ -83,5 +84,6 @@
 			cauintens = std::min(cauintens, 100.0f);
 			float intensity = pow( cauintens / 100.0f, 2 );
-			Fparams->setNamedConstant("CauSpriteIntens", intensity);				
+			float causticColor[] = {1.0, 1.0, 1.0, intensity};
+			Fparams->setNamedConstant("CausticColor", causticColor, 4);					
 		}
 		if (mInputDevice->isKeyDown(KC_MULTIPLY))
@@ -95,24 +97,5 @@
 			Vparams->setNamedConstant("CauSpriteSize", causize);			
 		}
-	*/
-		if (mInputDevice->isKeyDown(KC_SPACE))
-        {
-			mTimeUntilNextToggle = 2;
-			static bool first = true;
-			first = !first;
-			goldSphereNode->setVisible(first,true);
-			goldSphereNode->setVisible(!first,false);
-			aluSphereNode->setVisible(first,true);
-			aluSphereNode->setVisible(!first,false);
-			silverSphereNode->setVisible(first,true);
-			silverSphereNode->setVisible(!first,false);
-			copperSphereNode->setVisible(first,true);
-			copperSphereNode->setVisible(!first,false);
-			centerSphereNode->setVisible(first,true);
-			centerSphereNode->setVisible(!first,false);
-			
-		
-		}
-
+	
 		return ExampleFrameListener::processUnbufferedKeyInput(evt);
 	}
@@ -120,14 +103,15 @@
     {
 		static bool first = true;
-	/*	if(first)
+		if(first)
 		{
-			MaterialPtr mat = MaterialManager::getSingleton().getByName("GameTools/Cauathene_SE_0_clone");
+			MaterialPtr mat = MaterialManager::getSingleton().getByName("GTP/Caustic/CauCube_PointSpritecenterHead_SE_0_clone");
 			GpuProgramParameters* Vparams = mat->getTechnique(0)->getPass(0)->getVertexProgramParameters().getPointer();
 			GpuProgramParameters* Fparams = mat->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
-			float intensity = pow( cauintens / 100.0f, 2 );
-			Fparams->setNamedConstant("CauSpriteIntens", intensity);			
+			float intensity = cauintens;
+			float causticColor[] = {1.0, 1.0, 1.0, intensity};
+			Fparams->setNamedConstant("CausticColor", causticColor, 4);			
 			Vparams->setNamedConstant("CauSpriteSize", causize);
 			first = false;
-		}*/
+		}
 
 		lightNode->setPosition( 100.0 * Vector3(cos(-(float)framecount/500.0),2.0,sin(-(float)framecount/500.0)));
@@ -187,5 +171,8 @@
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("Bootstrap");
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("General");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Basic");
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("PostProc");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_EnvMap");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Caustic");
 	}
 
@@ -212,5 +199,5 @@
 		OgreIlluminationManager::getSingleton().setMainViewport(mWindow->getViewport(0));
 		
-		OgreIlluminationManager::getSingleton().setMaxJoinRadius(420);		
+		OgreIlluminationManager::getSingleton().setMaxJoinRadius(1000);		
 
 		Root::getSingleton()._setCurrentSceneManager(mSceneMgr);
@@ -237,25 +224,6 @@
 		Entity* aluHead = mSceneMgr->createEntity("aluHead", "head.mesh");
 
-		Entity* centerSphere = mSceneMgr->createEntity("centerSphere", "sphere.mesh");
-		Entity* goldSphere = mSceneMgr->createEntity("goldSphere", "sphere.mesh");
-		Entity* silverSphere = mSceneMgr->createEntity("silverSphere", "sphere.mesh");
-		Entity* copperSphere = mSceneMgr->createEntity("copperSphere", "sphere.mesh");
-		Entity* aluSphere = mSceneMgr->createEntity("aluSphere", "sphere.mesh");
-
-
-
 		kupola->setCastShadows(false);
-		//lod
-		//MeshPtr amesh = athene->getMesh();
-		//Mesh::LodDistanceList distances;
-		//distances.push_back(1);
-		//distances.push_back(2);
-		//distances.push_back(3);
-		//distances.push_back(4);
-		////distances.push_back(5);
-		//amesh->generateLodLevels(distances,ProgressiveMesh::VertexReductionQuota::VRQ_PROPORTIONAL,0.6);
-		//athene->setMeshLodBias(50000.0,0);
-		//tangents
-		//amesh->buildTangentVectors(0,1);
+		
 		MeshPtr kmesh = kupola->getMesh();
 		kmesh->buildTangentVectors(0,1);
@@ -270,49 +238,24 @@
 
 		centerSphereNode = rootNode->createChildSceneNode("centerSphere");
-		SceneNode* centerHeadNode = centerSphereNode->createChildSceneNode("centerHead");
 		centerSphereNode->setPosition(0, 100,0);
-		centerHeadNode->attachObject(centerHead);
-		centerSphereNode->attachObject(centerSphere);
-		centerSphereNode->setScale(0.4,0.4,0.4);
-		centerHeadNode->setScale(8,8,8);		
-		centerHeadNode->setVisible(false, false);
-		
-
+		centerSphereNode->attachObject(centerHead);
+		centerSphereNode->setScale(3.2, 3.2, 3.2);
+		
 		goldSphereNode = rootNode->createChildSceneNode( "goldSphere" );
-		SceneNode* goldHeadNode = goldSphereNode->createChildSceneNode( "goldHead" );
-		goldSphereNode->scale(0.3,0.3,0.3);
-		goldHeadNode->setScale(8,8,8);
-		goldHeadNode->setVisible(false, false);
-
+		goldSphereNode->scale(2.4, 2.4, 2.4);
+		goldSphereNode->attachObject(goldHead);
+		
 		silverSphereNode = rootNode->createChildSceneNode( "silverSphere" );
-		SceneNode* silverHeadNode = silverSphereNode->createChildSceneNode( "silverHead" );
-		silverSphereNode->scale(0.3,0.3,0.3);
-		silverHeadNode->setScale(8,8,8);
-		silverHeadNode->setVisible(false, false);
-
+		silverSphereNode->scale(2.4, 2.4, 2.4);
+		silverSphereNode->attachObject(silverHead);
+		
 		aluSphereNode = rootNode->createChildSceneNode( "aluSphere" );
-		SceneNode* aluHeadNode = aluSphereNode->createChildSceneNode( "aluHead" );
-		aluSphereNode->scale(0.3,0.3,0.3);
-		aluHeadNode->setScale(8,8,8);
-		aluHeadNode->setVisible(false, false);
-
+		aluSphereNode->scale(2.4, 2.4, 2.4);
+		aluSphereNode->attachObject(aluHead);
+		
 		copperSphereNode = rootNode->createChildSceneNode( "copperSphere" );
-		SceneNode* copperHeadNode = copperSphereNode->createChildSceneNode( "copperHead" );
-		copperSphereNode->scale(0.3,0.3,0.3);
-		copperHeadNode->setScale(8,8,8);
-		copperHeadNode->setVisible(false, false);
-		
-
-		goldSphereNode->attachObject(goldSphere);
-		silverSphereNode->attachObject(silverSphere);
-		aluSphereNode->attachObject(aluSphere);
-		copperSphereNode->attachObject(copperSphere);
-		
-		goldHeadNode->attachObject(goldHead);
-		silverHeadNode->attachObject(silverHead);
-		aluHeadNode->attachObject(aluHead);
-		copperHeadNode->attachObject(copperHead);
-	
-
+		copperSphereNode->scale(2.4, 2.4, 2.4);
+		copperSphereNode->attachObject(copperHead);
+		
 		goldSphereNode->_updateBounds();
 		silverSphereNode->_updateBounds();
@@ -320,13 +263,8 @@
 		copperSphereNode->_updateBounds();
 
-		goldHeadNode->_updateBounds();
-		silverHeadNode->_updateBounds();
-		aluHeadNode->_updateBounds();
-		copperHeadNode->_updateBounds();
-
+		
 		kupolaNode->_updateBounds();
 		centerSphereNode->_updateBounds();
-		centerHeadNode->_updateBounds();
-
+		
 		//Init lights
 		mainLight = mSceneMgr->createLight("MainLight");
@@ -345,21 +283,18 @@
 		mainLightNode->attachObject(bbs);
 		
-		silverSphere->setMaterialName("EnvMetals/Silver");
-		copperSphere->setMaterialName("EnvMetals/Copper");
-		goldSphere->setMaterialName("EnvMetals/Gold");
-		aluSphere->setMaterialName("EnvMetals/Alu");
-
-		aluHead->setMaterialName("EnvMetals/Alu");
-		copperHead->setMaterialName("EnvMetals/Copper");
-		goldHead->setMaterialName("EnvMetals/Gold");
-		silverHead->setMaterialName("EnvMetals/Silver");
-			
-
-		centerSphere->setMaterialName("GameTools/CausticGlass");
-		centerHead->setMaterialName("GameTools/CausticGlass");
-		
-		OgreIlluminationManager::getSingleton().initTechniques();
-		
-		
+		
+		aluHead->setMaterialName("GTP/EnvMap/Alu");
+		copperHead->setMaterialName("GTP/EnvMap/Copper");
+		goldHead->setMaterialName("GTP/EnvMap/Gold");
+		silverHead->setMaterialName("GTP/EnvMap/Silver");
+		centerHead->setMaterialName("GTP/Caustic/Glass");
+
+		/*aluHead->setVisible(false);
+		copperHead->setVisible(false);
+		goldHead->setVisible(false);
+		silverHead->setVisible(false);
+		centerHead->setVisible(false);*/
+
+		OgreIlluminationManager::getSingleton().initTechniques();	
    }
 
Index: GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1879)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 2057)
@@ -30,8 +30,30 @@
 #include "FrameCapture.h"
 
-int scene = 1;
+float refIndex = 0.77;
+int scene = 3;
 FrameCapture* capture;
 
 bool multiplebounce = true;
+
+int currentMaterial = 6;
+int currentObject = 0;
+String objectNames[] = {String("sphere.mesh"),
+                        String("teapot.mesh")};
+
+String materialNames[] = {String("GTP/MultiBounce/Reflector"),
+							String("GTP/MultiBounce/Refractor"),
+							String("GTP/MultiBounce/CausticRefractor"),
+							String("GTP/MultiBounce/Reflector_MinMax"),
+							String("GTP/MultiBounce/Refractor_MinMax"),
+							String("GTP/MultiBounce/CausticRefractor_MinMax"),
+							String("GTP/MultiBounce/Refractor2L")};
+                        
+String resourceGroupName[] = {	String("GTP_MultipleReflection"),
+								String("GTP_MultipleRefraction"),
+								String("GTP_MultipleRefraction"),
+								String("GTP_MultipleReflection_MinMax"),
+								String("GTP_MultipleRefraction_MinMax"),
+								String("GTP_MultipleRefraction_MinMax"),
+								String("GTP_MultipleRefraction2L")};
 
 // Listener class for frame updates
@@ -52,5 +74,5 @@
 		this->mMoveSpeed = 1.0;
 		if(scene == 3)
-		this->mMoveSpeed = 5.0;
+		this->mMoveSpeed = 10.0;
 		 mStatsOn = false;
 		 showDebugOverlay(mStatsOn);
@@ -79,5 +101,31 @@
 		float elapsed = thisTime - lastTime;
 		float move = elapsed * 0.25;
+		if(scene == 3)
+			move *= 10;
 		float rotate = 80.0 * move;
+
+		if (mInputDevice->isKeyDown(KC_J))
+        {
+			MaterialPtr mat1 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/Refractor2L");
+			GpuProgramParameters* Fparams1 = mat1->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			MaterialPtr mat2 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/PhotonMap2L");
+			GpuProgramParameters* Fparams2 = mat2->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			
+			refIndex -= 0.001;
+
+			Fparams1->setNamedConstant("refIndex", refIndex);
+			Fparams2->setNamedConstant("refIndex", refIndex);
+        }
+		if (mInputDevice->isKeyDown(KC_K))
+        {
+			MaterialPtr mat1 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/Refractor2L");
+			GpuProgramParameters* Fparams1 = mat1->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			MaterialPtr mat2 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/PhotonMap2L");
+			GpuProgramParameters* Fparams2 = mat2->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			
+			refIndex += 0.001;
+			Fparams1->setNamedConstant("refIndex", refIndex);
+			Fparams2->setNamedConstant("refIndex", refIndex);
+        }
 
 		if (mInputDevice->isKeyDown(KC_UP))
@@ -277,4 +325,21 @@
 
     }
+    
+	void loadResources(void)
+	{
+		// Initialise, parse scripts etc
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("Bootstrap");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("General");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("PostProc");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Basic");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_EnvMap");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Caustic");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_MultiBounce_Shared");
+		ResourceGroupManager::getSingleton().initialiseResourceGroup(resourceGroupName[currentMaterial]);
+		if(currentMaterial == 2)
+			ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_MultiBounce_PhotonMap");
+		if(currentMaterial == 5)
+			ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_MultiBounce_PhotonMap_MinMax");
+	}
 
 	void createScene(void)
@@ -314,19 +379,17 @@
 		//mCamera->lookAt(Vector3(0,1.2,0.0));
 		
-		bool teapot = true;
 		Entity* object;
-		if(teapot)
-		object = mSceneMgr->createEntity("object", "teapot.mesh");
-		else
-          object = mSceneMgr->createEntity("object", "sphere.mesh");
-
-		object->setMaterialName("MetalTeapotMultipleBounce");
+		object = mSceneMgr->createEntity("object", objectNames[currentObject]);
+		 
+		object->setMaterialName(materialNames[currentMaterial]);
 		objectNode = rootNode->createChildSceneNode("objectNode");
 		objectNode->attachObject(object);
-		if(teapot)
-		objectNode->scale(0.5,0.5,0.5);
-		else
-		objectNode->scale(0.005,0.005,0.005);
+		
+		if(currentObject == 1)
+			objectNode->scale(0.5,0.5,0.5);
+		if(currentObject == 0)
+			objectNode->scale(0.005,0.005,0.005);
 		//objectNode->scale(0.005,0.005,0.005);
+		
 		objectNode->setPosition(0,1.2,0);
 		objectNode->_updateBounds();
@@ -381,5 +444,5 @@
 		
 		mCamera->setPosition(2.3,7.0,2.3);
-		mCamera->lookAt(Vector3(0,5.75,0.0));
+		//mCamera->lookAt(Vector3(0,5.75,0.0));
 		
 		Entity* object = mSceneMgr->createEntity("object", "teapot.mesh");
@@ -410,28 +473,26 @@
 
 	void createScene3(void)
-    {
+    {	   
      	SceneNode* rootNode = mSceneMgr->getRootSceneNode();
 		
-		bool teapot = true;
 		//mCamera->getParentSceneNode()->translate(Vector3(6.564,4.328,0.059));
 		//mCamera->setPosition(4.0,4.2,-3.5);
-		mCamera->setPosition(7.0,2.6,-0.5);
-		mCamera->lookAt(Vector3(1.0, 0.0,0.6));
+		mCamera->getParentSceneNode()->translate(7.0,2.6,-0.5);
+		//mCamera->setPosition(7.0,2.6,-0.5);
+		//mCamera->lookAt(Vector3(1.0, 0.0,0.6));
 		Entity* object;
-
-		if(teapot)
-		 object = mSceneMgr->createEntity("object", "teapot.mesh");
-		else
-		 object = mSceneMgr->createEntity("object", "sphere.mesh");
-		object->setMaterialName("MetalTeapotMultipleBounce");
+		
+		object = mSceneMgr->createEntity("object", objectNames[currentObject]);
+
+		object->setMaterialName(materialNames[currentMaterial]);
 		objectNode = rootNode->createChildSceneNode();
 		objectNode->attachObject(object);
 
-		if(teapot)
+		if(currentObject == 1)
 		{
 		  objectNode->scale(2.7,2.7,2.7);
 		  objectNode->setPosition(0,0.7,0.0);
 		}
-		else
+		if(currentObject == 0)
 		{
 		  objectNode->scale(0.027,0.027,0.027);		
@@ -445,5 +506,24 @@
 		SceneNode* roomNode = rootNode->createChildSceneNode();
 		roomNode->attachObject(room);
-		roomNode->_updateBounds();					
+		roomNode->setScale(2,2,2);
+		roomNode->_updateBounds();
+
+		mSceneMgr->setShadowTechnique(SHADOWTYPE_NONE);
+		Light* Light1 = mSceneMgr->createLight("Light1");
+		Light1->setType(Light::LT_SPOTLIGHT);
+		Light1->setCastShadows(true);
+        Light1->setDiffuseColour(ColourValue(1,1, 1));
+		Light1->setPowerScale(1.0);
+		SceneNode* LightNode1 = rootNode->createChildSceneNode();
+		LightNode1->setPosition(3,3,3);
+		Light1->setDirection(-1,-1,-1);
+		Light1->setSpotlightRange(Degree(0),Degree(120));
+		LightNode1->attachObject(Light1);
+
+		BillboardSet* bbs = mSceneMgr->createBillboardSet("bb", 1);
+		bbs->setDefaultDimensions(0.2, 0.2);
+		bbs->createBillboard(Vector3::ZERO, ColourValue::White);
+		bbs->setMaterialName("Flare");
+		LightNode1->attachObject(bbs);
    }
 
Index: GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/scripts/ReflectionTest.7.10.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/scripts/ReflectionTest.7.10.vcproj	(revision 2025)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/scripts/ReflectionTest.7.10.vcproj	(revision 2057)
@@ -2,17 +2,13 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="7,00"
+	Version="7.10"
 	Name="ReflectionTest"
 	ProjectGUID="{945CF851-1CE7-469B-AB24-82A7C12C7170}"
 	RootNamespace="GameToolsRaytraceDemo"
-	Keyword="Win32Proj"
-	>
+	Keyword="Win32Proj">
 	<Platforms>
 		<Platform
-			Name="Win32"
-		/>
+			Name="Win32"/>
 	</Platforms>
-	<ToolFiles>
-	</ToolFiles>
 	<Configurations>
 		<Configuration
@@ -21,22 +17,5 @@
 			IntermediateDirectory="..\obj\$(ConfigurationName)"
 			ConfigurationType="1"
-			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
-			CharacterSet="2"
-			>
-			<Tool
-				Name="VCPreBuildEventTool"
-			/>
-			<Tool
-				Name="VCCustomBuildTool"
-			/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"
-			/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"
-			/>
-			<Tool
-				Name="VCMIDLTool"
-			/>
+			CharacterSet="2">
 			<Tool
 				Name="VCCLCompilerTool"
@@ -44,22 +23,14 @@
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns;..\..\Common\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
-				MinimalRebuild="true"
+				MinimalRebuild="TRUE"
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="3"
-				EnableFunctionLevelLinking="true"
+				EnableFunctionLevelLinking="TRUE"
 				UsePrecompiledHeader="0"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
-				DebugInformationFormat="4"
-			/>
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
 			<Tool
-				Name="VCManagedResourceCompilerTool"
-			/>
-			<Tool
-				Name="VCResourceCompilerTool"
-			/>
-			<Tool
-				Name="VCPreLinkEventTool"
-			/>
+				Name="VCCustomBuildTool"/>
 			<Tool
 				Name="VCLinkerTool"
@@ -69,35 +40,30 @@
 				AdditionalLibraryDirectories="..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\bin\Debug;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\bin\Debug"
 				IgnoreDefaultLibraryNames=""
-				GenerateDebugInformation="true"
+				GenerateDebugInformation="TRUE"
 				ProgramDatabaseFile="$(OutDir)/proba.pdb"
 				SubSystem="2"
 				OptimizeForWindows98="1"
-				TargetMachine="1"
-			/>
+				TargetMachine="1"/>
 			<Tool
-				Name="VCALinkTool"
-			/>
-			<Tool
-				Name="VCManifestTool"
-			/>
-			<Tool
-				Name="VCXDCMakeTool"
-			/>
-			<Tool
-				Name="VCBscMakeTool"
-			/>
-			<Tool
-				Name="VCFxCopTool"
-			/>
-			<Tool
-				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
-			/>
+				Name="VCMIDLTool"/>
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\..\bin\$(ConfigurationName)"
-			/>
+				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\..\bin\$(ConfigurationName)"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
 		</Configuration>
 		<Configuration
@@ -106,52 +72,27 @@
 			IntermediateDirectory="..\obj\$(ConfigurationName)"
 			ConfigurationType="1"
-			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
 			CharacterSet="2"
-			WholeProgramOptimization="1"
-			>
-			<Tool
-				Name="VCPreBuildEventTool"
-			/>
-			<Tool
-				Name="VCCustomBuildTool"
-			/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"
-			/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"
-			/>
-			<Tool
-				Name="VCMIDLTool"
-			/>
+			WholeProgramOptimization="TRUE">
 			<Tool
 				Name="VCCLCompilerTool"
 				Optimization="2"
 				InlineFunctionExpansion="1"
-				EnableIntrinsicFunctions="true"
+				EnableIntrinsicFunctions="TRUE"
 				FavorSizeOrSpeed="1"
-				OmitFramePointers="true"
-				EnableFiberSafeOptimizations="false"
+				OmitFramePointers="TRUE"
+				EnableFiberSafeOptimizations="FALSE"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns;..\..\Common\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
-				StringPooling="true"
-				MinimalRebuild="true"
+				StringPooling="TRUE"
+				MinimalRebuild="TRUE"
 				RuntimeLibrary="2"
-				BufferSecurityCheck="false"
-				EnableFunctionLevelLinking="true"
+				BufferSecurityCheck="FALSE"
+				EnableFunctionLevelLinking="TRUE"
 				UsePrecompiledHeader="0"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="true"
-				DebugInformationFormat="3"
-			/>
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
 			<Tool
-				Name="VCManagedResourceCompilerTool"
-			/>
-			<Tool
-				Name="VCResourceCompilerTool"
-			/>
-			<Tool
-				Name="VCPreLinkEventTool"
-			/>
+				Name="VCCustomBuildTool"/>
 			<Tool
 				Name="VCLinkerTool"
@@ -160,36 +101,31 @@
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\bin\Release;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\bin\Release"
-				GenerateDebugInformation="false"
+				GenerateDebugInformation="FALSE"
 				SubSystem="2"
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
 				OptimizeForWindows98="1"
-				TargetMachine="1"
-			/>
+				TargetMachine="1"/>
 			<Tool
-				Name="VCALinkTool"
-			/>
-			<Tool
-				Name="VCManifestTool"
-			/>
-			<Tool
-				Name="VCXDCMakeTool"
-			/>
-			<Tool
-				Name="VCBscMakeTool"
-			/>
-			<Tool
-				Name="VCFxCopTool"
-			/>
-			<Tool
-				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
-			/>
+				Name="VCMIDLTool"/>
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\..\bin\$(ConfigurationName)"
-			/>
+				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\..\bin\$(ConfigurationName)"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
 		</Configuration>
 	</Configurations>
@@ -199,43 +135,33 @@
 		<Filter
 			Name="Source Files"
-			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm"
-			>
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm">
 			<File
-				RelativePath="..\src\ReflectionTest.cpp"
-				>
+				RelativePath="..\src\ReflectionTest.cpp">
 			</File>
 		</Filter>
 		<Filter
 			Name="Header Files"
-			Filter="h;hpp;hxx;hm;inl;inc"
-			>
+			Filter="h;hpp;hxx;hm;inl;inc">
 			<File
-				RelativePath="..\..\Common\src\FrameCapture.cpp"
-				>
+				RelativePath="..\..\Common\src\FrameCapture.cpp">
 			</File>
 			<File
-				RelativePath="..\..\Common\include\FrameCapture.h"
-				>
+				RelativePath="..\..\Common\include\FrameCapture.h">
 			</File>
 			<File
-				RelativePath="..\include\ReflectionTest.h"
-				>
+				RelativePath="..\include\ReflectionTest.h">
 			</File>
 		</Filter>
 		<Filter
 			Name="Resource Files"
-			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe"
-			>
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe">
 			<File
-				RelativePath="..\..\..\Media\materials\programs\MetalTeapot.hlsl"
-				>
+				RelativePath="..\..\..\Media\materials\programs\MetalTeapot.hlsl">
 			</File>
 			<File
-				RelativePath="..\..\..\Media\materials\scripts\MetalTeapot.material"
-				>
+				RelativePath="..\..\..\Media\materials\scripts\MetalTeapot.material">
 			</File>
 			<File
-				RelativePath="..\..\..\Media\materials\programs\MetalTeapotNew.hlsl"
-				>
+				RelativePath="..\..\..\Media\materials\programs\MetalTeapotNew.hlsl">
 			</File>
 		</Filter>